#define ZASM_ASSEMBLER_C 1

#include <zasm/memory.h>
#include <zasm/assembler.h>

struct assembler_t *assembler_new(struct processor_t *proc)
{
  struct assembler_t *val;

  ALLOCATE(struct assembler_t, val, 1);
  assembler_fill(val, proc);
  return val;
}

void assembler_fill(struct assembler_t *asmb, struct processor_t *proc)
{
  asmb->proc = proc;
  asmb->look_ahead.type = TOKENS_COUNT;
}

// assembler_execute: in asm.parser

void assembler_delete(struct assembler_t *asmb)
{
  //  processor_free(asmb->proc);
}

void assembler_free(struct assembler_t *asmb)
{
  assembler_delete(asmb);
  free(asmb);
}
