#ifndef ZASM_ASSEMBLER_H
#define ZASM_ASSEMBLER_H 1

#include <zasm/tokens.h>

#define ASSEMBLER_T(O) ((struct assembler_t *)(O))
struct assembler_t
{
  struct processor_t *proc;
  struct token_t look_ahead;
};

#include <zasm/processor.h>
#include <zasm/stream.h>
#include <zasm/expr.h>


struct assembler_t *assembler_new(struct processor_t *proc);
void assembler_fill(struct assembler_t *asmb, struct processor_t *proc);
void assembler_execute(struct feeder_t *input, struct stream_t *output, struct assembler_t *asmb);
void assembler_delete(struct assembler_t *asmb);
void assembler_free(struct assembler_t *asmb);

#endif
