#ifndef ZASM_LIST_H
#define ZASM_LIST_H 1

#include <zasm/tokens.h>
#include <stdio.h>

#define foreach(T,L) for (list_start_begin(L), T = list_read_begin(L); T.type != TOK_LIST_END; T = list_read_begin(L))

#define LIST_T(O) ((struct list_t *)(O))
struct list_t
{
  // private
  struct token_t *data;
  struct token_t *mem;
  int begin;
  int index;
  int end;
  int mem_begin;
  int mem_end;
};

struct list_t *list_new      ();
void           list_fill     (struct list_t *list);
void           list_print    (struct list_t *list, FILE *file);
void           list_reverse  (struct list_t *list);
int            list_length   (struct list_t *list);
int            list_is_empty (struct list_t *list);
void           list_start_begin(struct list_t *list);
void           list_start_end(struct list_t *list);
struct token_t list_read_begin(struct list_t *list);
struct token_t list_read_end  (struct list_t *list);
struct token_t list_read_index(struct list_t *list, int index);
struct token_t list_get_begin(struct list_t *list);
struct token_t list_get_end  (struct list_t *list);
void           list_add_begin(struct list_t *list, struct token_t token);
void           list_add_end  (struct list_t *list, struct token_t token);
struct list_t *list_concat   (struct list_t *list1, struct list_t *list2);
void           list_add_list_begin(struct list_t *list, struct list_t *tokens);
void           list_add_list_end  (struct list_t *list, struct list_t *tokens);
void           list_allocate (struct list_t *list, int count);
void           list_set_original(struct list_t *list, struct token_t original);
struct list_t *list_copy     (struct list_t *list);
void           list_inc_refcount(struct list_t *list); // increase the refcount for the tokens in the list
void           list_dec_refcount(struct list_t *list); // increase the refcount for the tokens in the list
void           list_delete   (struct list_t *list);
void           list_free     (struct list_t *list);

#endif
