#ifndef ZASM_INTEL_HEX_WRITER_H
#define ZASM_INTEL_HEX_WRITER_H 1

#include <zasm/processor.h>

#define INTEL_HEX_WRITER_T(O) ((struct intel_hex_writer_t *)(O))
struct intel_hex_writer_t
{
  FILE *file;
  int endianness;
  int page;

  int length;
  int address;
  int type;
  char data[32];
  int checksum;
};

struct intel_hex_writer_t *intel_hex_writer_new(char *filename, int endianness);
void intel_hex_writer_fill(struct intel_hex_writer_t *writer, char *filename, int endianness);
void intel_hex_writer_execute(struct feeder_t *input, struct stream_t *output, struct intel_hex_writer_t *writer);
void intel_hex_writer_delete(struct intel_hex_writer_t *writer);
void intel_hex_writer_free(struct intel_hex_writer_t *writer);

#endif
